#ifndef _SFMT_SPU_H_
#define _SFMT_SPU_H_

#include <spu_intrinsics.h>
#include <vec_types.h>

#define vec_perm(a, b, c) \
  (vec_uint4)spu_shuffle((vec_uchar16)(a), (vec_uchar16)(b), spu_and((c), 0x1f))
#define vec_sr(a, b) \
  (vec_uint4)spu_rlmask((vec_uint4)(a), spu_sub(0, (vec_int4)(spu_and((vec_uint4)(b), 31))))
#define vec_sl(a, b) \
  (vec_uint4)spu_sl((a), spu_and((b), 31))
#define vec_xor(a, b)	\
  (vec_uint4)spu_xor((vec_uint4)(a), (vec_uint4)(b))
#define vec_and(a, b)	\
  (vec_uint4)spu_and((vec_uint4)(a), (vec_uint4)(b))

#endif /* _SFMT_SPU_H_ */
